--- //depot/projects/trustedbsd/mac/sys/kern/kern_mac.c	2003/06/07 22:05:57
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/kern/kern_mac.c	2003/06/13 16:12:32
@@ -68,6 +68,10 @@
 #include <sys/pipe.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <vm/vm.h>
 #include <vm/pmap.h>
@@ -171,6 +175,11 @@
     &mac_enforce_system, 0, "Enforce MAC policy on system operations");
 TUNABLE_INT("security.mac.enforce_system", &mac_enforce_system);
 
+static int	mac_enforce_sysv = 1;
+SYSCTL_INT(_security_mac, OID_AUTO, enforce_sysv, CTLFLAG_RW,
+    &mac_enforce_sysv, 0, "Enforce MAC policy on SystemV ipc  system objects");
+TUNABLE_INT("security.mac.enforce_sysv", &mac_enforce_sysv);
+
 static int	mac_enforce_vm = 1;
 SYSCTL_INT(_security_mac, OID_AUTO, enforce_vm, CTLFLAG_RW,
     &mac_enforce_vm, 0, "Enforce MAC policy on vm operations");
@@ -833,6 +842,36 @@
 	mac_init_ifnet_label(&ifp->if_label);
 }
 
+void 
+mac_init_ipc_msgmsg(struct msg *msgptr)
+{
+				mac_init_label(&msgptr->label);
+				MAC_PERFORM(init_ipc_msgmsg_label, &msgptr->label);
+}
+
+void 
+mac_init_ipc_msgqueue(struct msqid_kernel *msqkptr)
+{
+				mac_init_label(&msqkptr->label);
+				MAC_PERFORM(init_ipc_msgqueue_label, &msqkptr->label);
+}
+
+void  
+mac_init_ipc_sema(struct semid_kernel *semakptr)
+{
+
+				mac_init_label(&semakptr->label);
+				MAC_PERFORM(init_ipc_sema_label, &semakptr->label);
+}
+
+void 
+mac_init_ipc_shm(struct shmid_kernel *shmsegptr)
+{
+
+				mac_init_label(&shmsegptr->label);
+				MAC_PERFORM(init_ipc_shm_label, &shmsegptr->label);
+}
+
 int
 mac_init_ipq(struct ipq *ipq, int flag)
 {
@@ -1080,6 +1119,38 @@
 }
 
 void
+mac_destroy_ipc_msgmsg(struct msg *msgptr)
+{
+
+	MAC_PERFORM(destroy_ipc_msgmsg_label, &msgptr->label);
+	mac_destroy_label(&msgptr->label);
+}
+
+void
+mac_destroy_ipc_msgqueue(struct msqid_kernel *msqkptr)
+{
+
+	MAC_PERFORM(destroy_ipc_msgqueue_label, &msqkptr->label);
+	mac_destroy_label(&msqkptr->label);
+}
+
+void
+mac_destroy_ipc_sema(struct semid_kernel *semakptr)
+{
+
+	MAC_PERFORM(destroy_ipc_sema_label, &semakptr->label);
+	mac_destroy_label(&semakptr->label);
+}
+
+void
+mac_destroy_ipc_shm(struct shmid_kernel *shmsegptr)
+{
+
+  MAC_PERFORM(destroy_ipc_shm_label, &shmsegptr->label);
+  mac_destroy_label(&shmsegptr->label);
+}
+
+void
 mac_destroy_ipq(struct ipq *ipq)
 {
 
@@ -2238,6 +2309,34 @@
 	MAC_PERFORM(create_bpfdesc, cred, bpf_d, &bpf_d->bd_label);
 }
 
+void 
+mac_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr)
+{
+				
+	MAC_PERFORM(create_ipc_msgmsg, cred, msgptr, &msgptr->label);
+}
+
+void 
+mac_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+				
+	MAC_PERFORM(create_ipc_msgqueue, cred, msqkptr, &msqkptr->label);
+}
+
+void 
+mac_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr)
+{
+
+	MAC_PERFORM(create_ipc_sema, cred, semakptr, &semakptr->label);
+}
+
+void 
+mac_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+
+	MAC_PERFORM(create_ipc_shm, cred, shmsegptr, &shmsegptr->label);
+}
+
 void
 mac_create_socket(struct ucred *cred, struct socket *socket)
 {
@@ -2489,6 +2588,33 @@
 	    &mp->mnt_fslabel);
 }
 
+void
+mac_cleanup_ipc_msgmsg(struct msg *msgptr)
+{
+	MAC_PERFORM(cleanup_ipc_msgmsg, &msgptr->label);
+}
+
+void 
+mac_cleanup_ipc_msgqueue(struct msqid_kernel *msqkptr)
+{
+				
+	MAC_PERFORM(cleanup_ipc_msgqueue, &msqkptr->label);
+}
+
+void 
+mac_cleanup_ipc_sema(struct semid_kernel *semakptr)
+{
+
+	MAC_PERFORM(cleanup_ipc_sema, &semakptr->label);
+}
+
+void 
+mac_cleanup_ipc_shm(struct shmid_kernel *shmsegptr)
+{
+
+	MAC_PERFORM(cleanup_ipc_shm, &shmsegptr->label);
+}
+
 int
 mac_check_bpfdesc_receive(struct bpf_d *bpf_d, struct ifnet *ifnet)
 {
@@ -2546,6 +2672,213 @@
 }
 
 int
+mac_check_ipc_msgmsq(struct ucred *cred, struct msg *msgptr, 
+	struct msqid_kernel *msqkptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msgmsq, cred,  msgptr, msqkptr);
+
+
+				return(error);
+}
+
+int
+mac_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msgrcv, cred,  msgptr);
+
+
+				return(error);
+}
+
+int
+mac_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msgrmid, cred,  msgptr);
+
+
+				return(error);
+}
+
+int
+mac_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msqget, cred, msqkptr);
+
+
+				return(error);
+}
+
+int
+mac_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msqsnd, cred, msqkptr);
+
+				return(error);
+}
+
+int
+mac_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msqrcv, cred, msqkptr);
+
+				return(error);
+}
+
+int
+mac_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,                  int cmd)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &msqkptr->label ??
+				MAC_CHECK(check_ipc_msqctl, cred, msqkptr, cmd);
+
+				return(error);
+}
+
+int
+mac_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr, int cmd)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &semakptr->label ??
+				MAC_CHECK(check_ipc_semctl, cred, semakptr, cmd);
+
+
+				return(error);
+}
+
+int
+mac_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &semakptr->label ??
+				MAC_CHECK(check_ipc_semget, cred, semakptr);
+
+				return(error);
+}
+
+int
+mac_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr, 
+								        size_t accesstype)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &semakptr->label ??
+				MAC_CHECK(check_ipc_semop, cred, semakptr, accesstype);
+
+				return(error);
+}
+
+int 
+mac_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								        int shmflg)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &shmsegptr->label ??
+				MAC_CHECK(check_ipc_shmat, cred, shmsegptr, shmflg);
+
+				return(error);
+}
+
+int
+mac_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+                        int cmd)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &shmsegptr->label ??
+				MAC_CHECK(check_ipc_shmctl, cred, shmsegptr, cmd);
+
+				return(error);
+}
+
+int 
+mac_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &shmsegptr->label ??
+				MAC_CHECK(check_ipc_shmdt, cred, shmsegptr);
+
+				return(error);
+}
+
+int 
+mac_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								        int shmflg)
+{
+				int error;
+
+				if (!mac_enforce_sysv)
+			    return (0);
+
+				//XXX: Should we also pass &shmsegptr->label ??
+				MAC_CHECK(check_ipc_shmget, cred, shmsegptr, shmflg);
+
+				return(error);
+}
+
+
+int
 mac_check_kenv_dump(struct ucred *cred)
 {
 	int error;
--- //depot/projects/trustedbsd/mac/sys/kern/sysv_ipc.c	2003/05/31 18:09:30
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/kern/sysv_ipc.c	2003/06/11 17:17:58
@@ -69,6 +69,13 @@
  * Check for ipc permission
  */
 
+
+/*
+ * Note: The MAC Framework doesnt add any hook to the ipcperm function as 
+ * fine-grained hooks are inserted throughout the ipc primitives. These hooks
+ * compliment the ipcperm check. 
+ */
+
 int
 ipcperm(td, perm, mode)
 	struct thread *td;
